/*--------------------------------------------------------------------
 *    The GMTPLUS-system:	@(#)gmtplus_mgg.h	1.2	9/12/95
 *
 *  Based on...
 *    The GMT-system:	@(#)gmt_mgg.h	2.4  7/22/93
 *
 *    Copyright (c) 1991 by P. Wessel and W. H. F. Smith
 *    See README file for copying and redistribution conditions.
 *--------------------------------------------------------------------*/
/*
 *    01/10/94 jcm GMT_Plus
 *
 * GMTPlus version 03/10/95 jcm
 * Modifications made for gmtplus database system.
 *
 */

#include "master_index.h"

/* GLOBAL VARIABLE FOR GMTPLUS_LIBDIR */
/* set in gmtpath_init() */
#ifndef PATH_MAX
#define PATH_MAX 1024
#endif
extern char LIBDIR[PATH_MAX];


struct GMT {
  int daymon[61];	/* Cumulative number of days up to last month */
  int first_year;	/* The year the cruise started */
} *gmt_init();

struct GMT_PLUS_REC {	/* Format of *.gmt file records */
	long int	ldata[6];
	short int	sdata[8];
};

struct COL_N {
	int tsec;
	int lat;
	int lon;
	int graw;
	int gfaa;
	int twtt;
	int tcor;
	int mtot;
	int manm;
	int mflt;
	int bad_flag;
	int user_long[6];
	int user_short[8];
};

/* binary vector to flag what's short and what's long */
int col_short[14];

/* global record of what *.gmtd says is in the columns */
struct GMT_PLUS_REC first_record;

typedef struct bin_flag {
	int data;
	struct bin_flag *next;
} bin_flag_type;
typedef bin_flag_type *bin_flag_ptr;

#define TRUE 1
#define FALSE 0

struct INFO {
    char legname[16];
    int leg_id;
    int gmt;
    bin_flag_ptr flags;
	int mark;
    struct INFO *next_info;
};


/******* PROTOTYPES ********/
void update_info(struct INFO *old_info, char *name, int id_no, int num_flags, int *flag);
int gmtpath_init();
int read_gmt_header(FILE *hp, struct COL_N *col, int *year, int *nrec, char *agency, char *cruise);
int gmt_time(int *time,int year,int month,int day,int hour,int minute,int second, struct GMT *GMT_struct);

void read_gmt_master_index();/* Used to be int, but no one used and no return */
int gmtpath_func (char *leg_path, char *head_path, char *leg);
int read_first_gmt_datarec(FILE *fp,struct COL_N *col); /* FIX: should be void return? */
int write_gmt_header(FILE *hp, struct COL_N *col, int year, int nrec, char *agency, char *cruise, char *filename);
int write_first_gmt_datarec(FILE *fp,struct COL_N *col);
int transfer_header_comments(FILE *from, FILE *to);
int add_pedigree(FILE *hp, const char *message);
int read_data_record(struct GMT_PLUS_REC *record, struct COL_N *col, FILE *fp);
int gmt_date(int time,int *year,int *month,int *day,int *hour,int *minute,int *second,struct GMT *GMT_struct);
