/* xsystem.h contains the declaration for the LEG and XOVER structures
 * used in the XSYSTEM programs
 *
 * Author:	Paul Wessel
 * Date:	18-FEB-1989
 *
 */
#include <stdio.h>
#include "x_system.h"

struct CORR leg[3000];

main (argc, argv)
int argc;
char **argv; {
	FILE *fp = NULL, *fpo = NULL;
	int i, nlegs, ascii = FALSE, error = FALSE, legsize = sizeof (struct CORR);
	char line[512];

	for (i = 1; i < argc; i++) {
		switch (argv[i][1]) {
			case 'X':
				fp = fopen (&argv[i][2], "r");
				break;
			case 'A':
				fp = fopen (&argv[i][2], "r");
				ascii = TRUE;
				break;
			case 'O':
				fpo = fopen (&argv[i][2], "w");
				break;
			default:
				error = TRUE;
				break;
		}
	}

	if (fpo == NULL) fpo = stdout;
	if (fp == NULL) fp = stdin;

	if (argc == 1 || error) {
		fprintf (stderr, "x_edit - convert between binary and ASCCI xocer correction tables\n");
		fprintf (stderr, "usage: x_edit [-Xbinfile -Aasciifile -Ooutfile]\n");
		fprintf (stderr, "	-A give ASCII filename, convert to binary (-O)\n");
		fprintf (stderr, "	-O name of output file\n");
		fprintf (stderr, "	-X give binary filename, convert to ASCII (-O)\n");
		exit (-1);
	}

	if (ascii) {
		i = 0;
		while (fgets (line, 512, fp)) {
			sscanf (line, "%s %hd %f %f %f %f %f %f",
			leg[i].name,
			&leg[i].year,
			&leg[i].dc_shift_gmt[0],
			&leg[i].dc_shift_gmt[1],
			&leg[i].dc_shift_gmt[2],
			&leg[i].drift_rate_gmt[0],
			&leg[i].drift_rate_gmt[1],
			&leg[i].drift_rate_gmt[2]);
			i++;
		}
		if (fp != stdin) fclose (fp);
		nlegs = i;
		for (i = 0; i < nlegs; i++)
                    fwrite((char *)&leg[i], legsize, 1, fpo);
            fclose(fpo);
	}
	else {
		i = 0;
		while (fread ((char *)&leg[i], legsize, 1, fp) == 1) i++;
		nlegs = i;
		fclose (fp);
		for (i = 0; i < nlegs; i++)
			fprintf (fpo, "%s\t%d\t%g\t%g\t%g\t%g\t%g\t%g\n",
			leg[i].name,
			leg[i].year,
			leg[i].dc_shift_gmt[0],
			leg[i].dc_shift_gmt[1],
			leg[i].dc_shift_gmt[2],
			leg[i].drift_rate_gmt[0],
			leg[i].drift_rate_gmt[1],
			leg[i].drift_rate_gmt[2]);
		if (fpo != stdout) fclose (fpo);
	}
}
